﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;

namespace XamDataChartMultiTooltipDemo
{
    public class CategoryTooltipContentPresenterBehavior : Behavior<ContentPresenter>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        private void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            ContentPresenter cp = sender as ContentPresenter;
            ContentControl cc1 = cp.Content as ContentControl;

            if (cc1 != null)
            {

                if (cc1.Tag != null)
                {
                    int i = 0;
                }

                ContentPresenter cp2 = cc1.Content as ContentPresenter;
                ContentControl cc2 = cp2.Content as ContentControl;

                StackPanel sp = cc2.Content as StackPanel;

                var z = sp.Children; //Content controls for series exist here!!

                Grid grid = new Grid();
                grid.ColumnDefinitions.Add(new ColumnDefinition());
                grid.ColumnDefinitions.Add(new ColumnDefinition());

                List<Grid> spChildren = new List<Grid>();

                foreach (var x in sp.Children)
                {
                    if (x is ContentControl)
                    {
                        CategoryToolTipItemContext itemContext = ((ContentControl)x).Content as CategoryToolTipItemContext;
                        ContentControl actualTooltip = itemContext.SubContent as ContentControl;

                        Grid tooltipContent = actualTooltip.Content as Grid;
                        tooltipContent.Margin = new Thickness(5);

                        itemContext.SubContent = null;
                        ((ContentControl)x).Content = null;
                        actualTooltip.Content = null;

                        spChildren.Add(tooltipContent);
                    }
                }

                sp.Children.Clear();

                StackPanel column1 = new StackPanel();
                StackPanel column2 = new StackPanel();


                for (int i = 0; i < spChildren.Count; i++)
                {
                    if (i % 2 == 0)
                    {
                        column1.Children.Add(spChildren[i]);
                    }
                    else
                    {
                        column2.Children.Add(spChildren[i]);
                    }
                }



                Grid.SetColumn(column2, 1);

                grid.Children.Add(column1);
                grid.Children.Add(column2);

                cc2.Content = grid;
            }
        }
    }
}
